/*****************************************************************************
 * Core B
 * Idle_CoreB.c
 *****************************************************************************/

#include <services/services.h>
#include <ccblkfn.h>

/* The following code idles the core B processor. It is recommended you do not
   modify this code. */
int main( void )
{
	/* Idle the processor. */
	while(1)
	{
		u32 TmpCoreBWakeupReg1 = *pSICB_IWR1;
		u32 TmpCoreBWakeupReg0 = *pSICB_IWR0;

		/* Disable all wakeups except the PLL */
		*pSICB_IWR1 = 0x00;
		*pSICB_IWR0 = 0x01;

		idle();

		/* Upon PLL wakeup from IDLE, re-enable wakeups */
		*pSICB_IWR1 = TmpCoreBWakeupReg1;
		*pSICB_IWR0 = TmpCoreBWakeupReg0;
	}
}
