#ifndef __INCLUDE_SPIF_H__
#define __INCLUDE_SPIF_H__

#define FPGA_SPIF_BASE   0x20000000
#define SPIF_WRITE8		 0x6000
#define SPIF_WRITE16	 0x6004
#define SPIF_WRITE24     0x6008
#define SPIF_WRITE32	 0x600c
#define SPIF_CTL		 0x6010
#define SPIF_MISO		 0x6014

#define SPIF_CTL_ENABLE		1
#define SPIF_CTL_DISABLE	0

#define SPIF_PTR(x)		((volatile unsigned int *)(FPGA_SPIF_BASE + (x)))

#define pSPIF_WRITE(x)	SPIF_PTR(SPIF_WRITE8-4+((x)*4))
#define pSPIF_WRITE8	SPIF_PTR(SPIF_WRITE8)
#define pSPIF_WRITE16	SPIF_PTR(SPIF_WRITE16)
#define pSPIF_WRITE24	SPIF_PTR(SPIF_WRITE24)
#define pSPIF_WRITE32	SPIF_PTR(SPIF_WRITE32)
#define pSPIF_CTL		SPIF_PTR(SPIF_CTL)
#define pSPIF_MISO		SPIF_PTR(SPIF_MISO)

#endif // __INCLUDE_SPIF_H__
