#ifndef __INCLUDE_TSC_H__
#define __INCLUDE_TSC_H__

#define FPGA_TSC_BASE    0x20040000
#define TSC_UC           0x0000
#define TSC_IP           0x0800
#define TSC_SR           0x0808
#define TSC_CR           0x080c

#define TSC_SR_RESET     0x00000001
#define TSC_SR_POWER     0x00000010
#define TSC_SR_DONE      0x00000100
#define TSC_SR_PC_MASK   0x01FF0000
#define TSC_SR_PC_SHIFT  16

#define TSC_CR_RESET     0x00000001
#define TSC_CR_POWER     0x00000010

#define TSC_PTR(x)		 ((volatile unsigned int *)(FPGA_TSC_BASE + (x)))

#define pTSC_UC(x)	     TSC_PTR(TSC_UC+(x)*4)
#define pTSC_IP          TSC_PTR(TSC_IP)
#define pTSC_SR          TSC_PTR(TSC_SR)
#define pTSC_CR          TSC_PTR(TSC_CR)

#endif // __INCLUDE_TSC_H__
