module crc32_8(clk, rst, en, i, q);

input         clk;
input         rst;
input         en;
input   [7:0] i;
output [31:0] q;

wire          k;
wire    [7:0] m;
wire   [31:0] c;

LUT6_2 #(64'h33CC33CC5A5A5A5A) lut0  (.O5(m[0]),  .O6(m[1]),  .I0(q[24]), .I1(q[25]), .I2(i[7]),  .I3(i[6]), .I4(1'b0), .I5(1'b1));
LUT6_2 #(64'h33CC33CC5A5A5A5A) lut1  (.O5(m[2]),  .O6(m[3]),  .I0(q[26]), .I1(q[27]), .I2(i[5]),  .I3(i[4]), .I4(1'b0), .I5(1'b1));
LUT6_2 #(64'h33CC33CC5A5A5A5A) lut2  (.O5(m[4]),  .O6(m[5]),  .I0(q[28]), .I1(q[29]), .I2(i[3]),  .I3(i[2]), .I4(1'b0), .I5(1'b1));
LUT6_2 #(64'h33CC33CC5A5A5A5A) lut3  (.O5(m[6]),  .O6(m[7]),  .I0(q[30]), .I1(q[31]), .I2(i[1]),  .I3(i[0]), .I4(1'b0), .I5(1'b1));
LUT6   #(64'h6996966996696996) lut4   (.O(k),                 .I0(q[25]), .I1(q[29]), .I2(q[30]), .I3(i[6]), .I4(i[2]), .I5(i[1]));
LUT6_2 #(64'h966969965555AAAA) lut5  (.O5(c[0]),  .O6(c[4]),  .I0(m[0]),  .I1(m[2]),  .I2(m[3]),  .I3(m[4]), .I4(m[6]), .I5(1'b1));
LUT6_2 #(64'h9669699666999966) lut6  (.O5(c[1]),  .O6(c[2]),  .I0(m[0]),  .I1(m[1]),  .I2(m[2]),  .I3(m[6]), .I4(m[7]), .I5(1'b1));
LUT5   #(32'h96696996)         lut7   (.O(c[5]),              .I0(m[0]),  .I1(m[3]),  .I2(m[4]),  .I3(m[7]), .I4(k));
LUT6_2 #(64'h696996963CC3C33C) lut8  (.O5(c[3]),  .O6(c[24]), .I0(q[16]), .I1(m[1]),  .I2(m[2]),  .I3(m[3]), .I4(m[7]), .I5(1'b1));
LUT6_2 #(64'hA55AA55A3CC3C33C) lut9  (.O5(c[6]),  .O6(c[30]), .I0(q[22]), .I1(m[2]),  .I2(m[4]),  .I3(m[7]), .I4(k),    .I5(1'b1));
LUT5   #(32'h96696996)         lut10  (.O(c[7]),              .I0(m[0]),  .I1(m[2]),  .I2(m[3]),  .I3(m[5]), .I4(m[7]));
LUT5   #(32'h96696996)         lut11  (.O(c[8]),              .I0(q[0]),  .I1(m[0]),  .I2(m[1]),  .I3(m[3]), .I4(m[4]));
LUT5   #(32'h96696996)         lut12  (.O(c[9]),              .I0(q[1]),  .I1(m[1]),  .I2(m[2]),  .I3(m[4]), .I4(m[5]));
LUT5   #(32'h96696996)         lut13  (.O(c[10]),             .I0(q[2]),  .I1(m[0]),  .I2(m[2]),  .I3(m[3]), .I4(m[5]));
LUT5   #(32'h96696996)         lut14  (.O(c[11]),             .I0(q[3]),  .I1(m[0]),  .I2(m[1]),  .I3(m[3]), .I4(m[4]));
LUT5   #(32'h96696996)         lut15  (.O(c[12]),             .I0(q[4]),  .I1(m[0]),  .I2(m[2]),  .I3(m[4]), .I4(k));
LUT5   #(32'h96696996)         lut16  (.O(c[13]),             .I0(q[5]),  .I1(m[2]),  .I2(m[3]),  .I3(m[7]), .I4(k));
LUT6   #(64'h6996966996696996) lut17  (.O(c[14]),             .I0(q[6]),  .I1(m[2]),  .I2(m[3]),  .I3(m[4]), .I4(m[6]), .I5(m[7]));
LUT5   #(32'h96696996)         lut18  (.O(c[15]),             .I0(q[7]),  .I1(m[3]),  .I2(m[4]),  .I3(m[5]), .I4(m[7]));
LUT6_2 #(64'h3333CCCC5AA5A55A) lut19 (.O5(c[16]), .O6(c[21]), .I0(q[8]),  .I1(q[13]), .I2(m[0]),  .I3(m[4]), .I4(m[5]), .I5(1'b1));
LUT2    #(4'h6)                lut20  (.O(c[17]),             .I0(q[9]),  .I1(k));
LUT4   #(16'h6996)             lut21  (.O(c[18]),             .I0(q[10]), .I1(m[2]),  .I2(m[6]),  .I3(m[7]));
LUT6_2 #(64'h3CC3C33CA5A55A5A) lut22 (.O5(c[19]), .O6(c[29]), .I0(q[11]), .I1(q[21]), .I2(m[3]),  .I3(m[6]), .I4(m[7]), .I5(1'b1));
LUT6_2 #(64'hC33CC33C5555AAAA) lut23 (.O5(c[20]), .O6(c[25]), .I0(q[12]), .I1(q[17]), .I2(m[2]),  .I3(m[3]), .I4(m[4]), .I5(1'b1));
LUT6_2 #(64'h3CC3C33C5A5A5A5A) lut24 (.O5(c[22]), .O6(c[23]), .I0(q[14]), .I1(q[15]), .I2(m[0]),  .I3(m[1]), .I4(m[6]), .I5(1'b1));
LUT5   #(32'h96696996)         lut25  (.O(c[26]),             .I0(q[18]), .I1(m[0]),  .I2(m[3]),  .I3(m[4]), .I4(m[6]));
LUT5   #(32'h96696996)         lut26  (.O(c[27]),             .I0(q[19]), .I1(m[1]),  .I2(m[4]),  .I3(m[5]), .I4(m[7]));
LUT6_2 #(64'h33CC33CC5AA5A55A) lut27 (.O5(c[28]), .O6(c[31]), .I0(q[20]), .I1(q[23]), .I2(m[2]),  .I3(m[5]), .I4(m[6]), .I5(1'b1));

FDSE fd0  (.Q(q[0]),  .C(clk), .CE(en), .S(rst), .D(c[0]));
FDSE fd1  (.Q(q[1]),  .C(clk), .CE(en), .S(rst), .D(c[1]));
FDSE fd2  (.Q(q[2]),  .C(clk), .CE(en), .S(rst), .D(c[2]));
FDSE fd3  (.Q(q[3]),  .C(clk), .CE(en), .S(rst), .D(c[3]));
FDSE fd4  (.Q(q[4]),  .C(clk), .CE(en), .S(rst), .D(c[4]));
FDSE fd5  (.Q(q[5]),  .C(clk), .CE(en), .S(rst), .D(c[5]));
FDSE fd6  (.Q(q[6]),  .C(clk), .CE(en), .S(rst), .D(c[6]));
FDSE fd7  (.Q(q[7]),  .C(clk), .CE(en), .S(rst), .D(c[7]));
FDSE fd8  (.Q(q[8]),  .C(clk), .CE(en), .S(rst), .D(c[8]));
FDSE fd9  (.Q(q[9]),  .C(clk), .CE(en), .S(rst), .D(c[9]));
FDSE fd10 (.Q(q[10]), .C(clk), .CE(en), .S(rst), .D(c[10]));
FDSE fd11 (.Q(q[11]), .C(clk), .CE(en), .S(rst), .D(c[11]));
FDSE fd12 (.Q(q[12]), .C(clk), .CE(en), .S(rst), .D(c[12]));
FDSE fd13 (.Q(q[13]), .C(clk), .CE(en), .S(rst), .D(c[13]));
FDSE fd14 (.Q(q[14]), .C(clk), .CE(en), .S(rst), .D(c[14]));
FDSE fd15 (.Q(q[15]), .C(clk), .CE(en), .S(rst), .D(c[15]));
FDSE fd16 (.Q(q[16]), .C(clk), .CE(en), .S(rst), .D(c[16]));
FDSE fd17 (.Q(q[17]), .C(clk), .CE(en), .S(rst), .D(c[17]));
FDSE fd18 (.Q(q[18]), .C(clk), .CE(en), .S(rst), .D(c[18]));
FDSE fd19 (.Q(q[19]), .C(clk), .CE(en), .S(rst), .D(c[19]));
FDSE fd20 (.Q(q[20]), .C(clk), .CE(en), .S(rst), .D(c[20]));
FDSE fd21 (.Q(q[21]), .C(clk), .CE(en), .S(rst), .D(c[21]));
FDSE fd22 (.Q(q[22]), .C(clk), .CE(en), .S(rst), .D(c[22]));
FDSE fd23 (.Q(q[23]), .C(clk), .CE(en), .S(rst), .D(c[23]));
FDSE fd24 (.Q(q[24]), .C(clk), .CE(en), .S(rst), .D(c[24]));
FDSE fd25 (.Q(q[25]), .C(clk), .CE(en), .S(rst), .D(c[25]));
FDSE fd26 (.Q(q[26]), .C(clk), .CE(en), .S(rst), .D(c[26]));
FDSE fd27 (.Q(q[27]), .C(clk), .CE(en), .S(rst), .D(c[27]));
FDSE fd28 (.Q(q[28]), .C(clk), .CE(en), .S(rst), .D(c[28]));
FDSE fd29 (.Q(q[29]), .C(clk), .CE(en), .S(rst), .D(c[29]));
FDSE fd30 (.Q(q[30]), .C(clk), .CE(en), .S(rst), .D(c[30]));
FDSE fd31 (.Q(q[31]), .C(clk), .CE(en), .S(rst), .D(c[31]));

endmodule
