module tscram(wclk, we, wa, wd, rclk, ra, rd);

input wclk;
input we;
input [8:0] wa;
input [29:0] wd;

input rclk;
input [8:0] ra;
output [29:0] rd;

wire [1:0] dummy;

RAMB16BWER ram (
    .DOA(), .DOB({dummy, rd}), .DOPA(), .DOPB(),
    .ADDRA({wa, 5'h00}), .ADDRB({ra, 5'h00}),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({2'b00, wd}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(1'b1), .REGCEA(1'b0), .REGCEB(1'b0),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram.DATA_WIDTH_A = 36;
defparam ram.DATA_WIDTH_B = 36;
defparam ram.SIM_DEVICE = "SPARTAN6";

endmodule
