module xram4096x32r8qa(wclk, we, wa, wd, rclk, re, ra, rd);

input        wclk;
input        we;
input [11:0] wa;
input [31:0] wd;

input        rclk;
input        re;
input [13:0] ra;
output [7:0] rd;

wire  [30:0] dummy0, dummy1, dummy2, dummy3, dummy4, dummy5, dummy6, dummy7;

RAMB16BWER ram0 (
    .DOA(), .DOB({dummy0, rd[0]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[24], wd[16], wd[8], wd[0]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram0.DATA_WIDTH_A = 4;
defparam ram0.DATA_WIDTH_B = 1;
defparam ram0.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram1 (
    .DOA(), .DOB({dummy1, rd[1]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[25], wd[17], wd[9], wd[1]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram1.DATA_WIDTH_A = 4;
defparam ram1.DATA_WIDTH_B = 1;
defparam ram1.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram2 (
    .DOA(), .DOB({dummy2, rd[2]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[26], wd[18], wd[10], wd[2]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram2.DATA_WIDTH_A = 4;
defparam ram2.DATA_WIDTH_B = 1;
defparam ram2.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram3 (
    .DOA(), .DOB({dummy3, rd[3]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[27], wd[19], wd[11], wd[3]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram3.DATA_WIDTH_A = 4;
defparam ram3.DATA_WIDTH_B = 1;
defparam ram3.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram4 (
    .DOA(), .DOB({dummy4, rd[4]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[28], wd[20], wd[12], wd[4]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram4.DATA_WIDTH_A = 4;
defparam ram4.DATA_WIDTH_B = 1;
defparam ram4.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram5 (
    .DOA(), .DOB({dummy5, rd[5]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[29], wd[21], wd[13], wd[5]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram5.DATA_WIDTH_A = 4;
defparam ram5.DATA_WIDTH_B = 1;
defparam ram5.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram6 (
    .DOA(), .DOB({dummy6, rd[6]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[30], wd[22], wd[14], wd[6]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram6.DATA_WIDTH_A = 4;
defparam ram6.DATA_WIDTH_B = 1;
defparam ram6.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram7 (
    .DOA(), .DOB({dummy7, rd[7]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 2'b00}), .ADDRB(ra),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({28'h0000000, wd[31], wd[23], wd[15], wd[7]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram7.DATA_WIDTH_A = 4;
defparam ram7.DATA_WIDTH_B = 1;
defparam ram7.SIM_DEVICE = "SPARTAN6";

endmodule
