module xram8192x8r32qa(wclk, we, wa, wd, rclk, re, ra, rd);

input         wclk;
input         we;
input  [12:0] wa;
input   [7:0] wd;

input         rclk;
input         re;
input  [10:0] ra;
output [31:0] rd;

wire   [23:0] dummy0, dummy1, dummy2, dummy3;

RAMB16BWER ram0 (
    .DOA(), .DOB({dummy0, rd[25:24], rd[17:16], rd[9:8], rd[1:0]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 1'b0}), .ADDRB({ra, 3'b000}),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({30'h0000000, wd[1:0]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram0.DATA_WIDTH_A = 2;
defparam ram0.DATA_WIDTH_B = 9;
defparam ram0.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram1 (
    .DOA(), .DOB({dummy1, rd[27:26], rd[19:18], rd[11:10], rd[3:2]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 1'b0}), .ADDRB({ra, 3'b000}),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({30'h0000000, wd[3:2]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram1.DATA_WIDTH_A = 2;
defparam ram1.DATA_WIDTH_B = 9;
defparam ram1.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram2 (
    .DOA(), .DOB({dummy2, rd[29:28], rd[21:20], rd[13:12], rd[5:4]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 1'b0}), .ADDRB({ra, 3'b000}),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({30'h0000000, wd[5:4]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram2.DATA_WIDTH_A = 2;
defparam ram2.DATA_WIDTH_B = 9;
defparam ram2.SIM_DEVICE = "SPARTAN6";

RAMB16BWER ram3 (
    .DOA(), .DOB({dummy2, rd[31:30], rd[23:22], rd[15:14], rd[7:6]}), .DOPA(), .DOPB(),
    .ADDRA({wa, 1'b0}), .ADDRB({ra, 3'b000}),
    .CLKA(wclk), .CLKB(rclk),
    .DIA({30'h0000000, wd[7:6]}), .DIB(32'h00000000), .DIPA(4'h0), .DIPB(4'h0),
    .ENA(we), .ENB(re), .REGCEA(1'b0), .REGCEB(1'b1),
    .RSTA(1'b0), .RSTB(1'b0), .WEA({4{we}}), .WEB(4'h0));
defparam ram3.DATA_WIDTH_A = 2;
defparam ram3.DATA_WIDTH_B = 9;
defparam ram3.SIM_DEVICE = "SPARTAN6";

endmodule
