#ifndef MICSER_H
#define MICSER_H

#include "ms_arch.h"

#define MS_FT_DIRECTORY   0
#define MS_FT_STATIC      1
#define MS_FT_GENERATED   2

#define MS_FNAME_SIZE     28
#define MS_MAX_CONNS      8
#define MS_MAX_REQ_SIZE   512

typedef struct {
    u32 type;
    union {
	struct {
	    u32 count;
	    u32 defent;
	    struct {
		u8 name[MS_FNAME_SIZE];
		u32 ptr;
	    } entries[1];
	} dir;
	struct {
	    u32 mime;
	    u32 size;
	    u8 data[1];
	} st;
	struct {
	    u32 mime;
	    u32 partial;
	    u32 link;
	} gen;
    };
} ms_file;

typedef u32 (*ms_gen_func)(u32 partial, u32 start, u32 *size, u8 **data);

void start_server(void *root, ms_gen_func *link, u16 port);

#endif
